#!/usr/bin/perl

use strict;
use warnings;
#use diagnostics;

BEGIN
{
    use vars qw(%cfg %options %query $tp);
    
    # Find working directory
    use FindBin;
    $options{rootdir} = $FindBin::Bin;
    #$options{rootdir} = "/var/www/admin";
}

use lib "$options{rootdir}/modules";

use CGI;
use DBI;
use HTML::Template;
use Netams::PerlAPI;

require "$options{rootdir}/config.pl";
require "$options{rootdir}/modules/Loaddata.pl";
require "$options{rootdir}/modules/Subs.pl";

our $VERSION = "0.80.3";

my $cgi = new CGI;
%query = $cgi->Vars;

#
# MAIN
#

# Connect to netams
&netams_login($cfg{host}, $cfg{port}, $cfg{login}, $cfg{pass});

# Generate Header
my $header = HTML::Template->new (filename => './html/header.tmpl');
$header->param (VERSION => $VERSION);

print "Content-type: text/html\n\n";
print $header->output;

# Execute actions and generate main content
my %switch = 
(
    default => "$options{rootdir}/modules/main.pl",
    unit    => "$options{rootdir}/modules/unit.pl",
    policy  => "$options{rootdir}/modules/policy.pl",
    quota   => "$options{rootdir}/modules/quota.pl",
    login   => "$options{rootdir}/modules/login.pl",
    count   => "$options{rootdir}/modules/count.pl",
    graph   => "$options{rootdir}/modules/graph.pl",
);
if ($switch{$query{'fn'}})  { require $switch{$query{'fn'}} }
else			    { require $switch{'default'} }

$tp->param(fn	    => $query{fn}) if 
    ($tp->query(name =>'fn')      eq 'VAR');
$tp->param(rooturl  => $cgi->url(-absolute => 1)) if 
    ($tp->query(name =>'rooturl') eq 'VAR');

print $tp->output;
    
# Generate footer
my $footer = HTML::Template->new (filename => './html/footer.tmpl');
    
print $footer->output;

# Disconnect from netams
&netams_logout;
