use strict;

sub chooseAction
{
    if ($_[0]->{$query{'act'}})	{ return $_[0]->{$query{'act'}} }
    else			{ return $_[0]->{'default'} }
}

sub logs 
{
    my $l_time = localtime();

    open (FH,">>log.htm");
	print FH "<pre>$l_time:\n$_[0]</pre>";
	close (FH);
}

# Connect to netams database
sub dbConnect
{
    return DBI->connect("DBI:mysql:$cfg{dbname}", "$cfg{dblogin}", "$cfg{dbpass}") or die("Can't connect to database \"$cfg{dbname}\"");
}

# Convert value or values to megabytes,
# with last character [KMG] striped.
sub convertToMB
{
    my @values = @_;
    
    foreach my $value (@values)
    {
	$value =~ s/^(.*)([KMG])$/$1/;
	    
	if	($2 eq "" ) { $value /= 1048576 }
	elsif	($2 eq "K") { $value /= 1024    }
	elsif   ($2 eq "G") { $value *= 1024    }
    }
    
    if	    (wantarray)		    { return (@values) }
    elsif   (defined(wantarray))    { return $values[0] }
    else			    { return }
}

########################
sub policySet {
########################

    # Arguments:
    # 0 - unit type
    # 1 - unit name
    # 2 - policy type
    # 3 - policy flag
    # 4 - policy name
    
    if	    ($_[3] eq "inv")	{ $_[3] = "!"; }
    elsif   ($_[3] eq "pas")	{ $_[3] = "%"; }
    elsif   ($_[3] eq "both")   { $_[3] = "%!"; }
	
    my $debug;

    $debug .= netams_cmd("service $cfg{nas_prc}");
    $debug .= netams_cmd("unit $_[0] name $_[1] $_[2]-policy $_[3]$_[4]");
    $debug .= netams_cmd("exit");
    $debug .= netams_cmd("save");
	
    return $debug;
}

########################
sub quotaSet {
########################
    
    # Arguments:
    # 0 - unit name
    # 1 - quota period (total hour week month)
    # 2 - quota (in MB)
    # 3 - destination (in out sum)
    
    # Round quota number to no more than 3 digits after decimal point,
    # than add trailing "M" - means megabytes for netams
    $_[2] = sprintf("%.3f%s", $_[2], "M");
    
    my $debug;
    
    $debug.=netams_cmd("service $cfg{nas_quo}");
    $debug.=netams_cmd("set name $_[0] $_[1] $_[2] $_[3]");
    $debug.=netams_cmd("exit");
    $debug.=netams_cmd("save");
	
    return $debug;
}

1;
