## NeTAMS (www.netams.com) admintool by RamireZ (ramirez@ru.ru)
##
## LOGINS MANAGEMENT MODULE

use strict;

# Load data
my ($UNIT, $UNIT_BYNAME) = &unitLoadData;
my $LOGIN		 = &loginLoadData;

my %switch =
(
    default => \&showList,
    view    => \&viewLogin,
    edit    => \&showSetLogin,
    set	    => \&makeSetLogin,
    logout  => \&showLogout,
    logout2 => \&makeLogout,
    login   => \&showLogin,
    login2  => \&makeLogin,
);

&{ &chooseAction(\%switch) };

###########################
sub viewLogin {
###########################
    $tp = HTML::Template->new(filename => './html/login/viewLogin.tmpl');
    $tp->param(	
			uid => $query{uid},
			name => $UNIT->{$query{uid}}{name},
			inact => $LOGIN->{$query{uid}}{inact},
			'abs' => $LOGIN->{$query{uid}}{'abs'},
			mac => $LOGIN->{$query{uid}}{ip},
			mac => $LOGIN->{$query{uid}}{mac},
			status => $LOGIN->{$query{uid}}{status},
			opened => $LOGIN->{$query{uid}}{status} eq "OPENED" ? 1 : 0,
			date1 => $LOGIN->{$query{uid}}{date1},
			time1 => $LOGIN->{$query{uid}}{time1},
			date2 => $LOGIN->{$query{uid}}{date2},
			time2 => $LOGIN->{$query{uid}}{time2},
		    );
}

###########################
sub showList {
###########################
    my (@logins, @notlogins);
    
    foreach my $uid (keys %$UNIT)
    {
	if ($LOGIN->{$uid}{status})
	{
	    # If unit is defined in a login service,
	    # add unit information to logins array.
	    push (@logins,
		{
		    fn	    => $query{fn},
		    uid	    => $uid,
		    name    => $UNIT->{$uid}{name},
		    status  => $LOGIN->{$uid}{status},
		    ip	    => $LOGIN->{$uid}{ip},
		    mac	    => $LOGIN->{$uid}{mac},
		    opened  => $LOGIN->{$uid}{status} eq "OPENED" ? 1 : 0,
		});
	}
	else
	{
	    # If unit is NOT defined in a login service,
	    # add unit information to notlogins array.
	    push (@notlogins,
		{ 
		    uid	    => $uid,
		    name    => $UNIT->{$uid}{name},
		});
	}
    }
     
    $tp = HTML::Template->new(filename => './html/login/showList.tmpl');
    $tp->param(	
		    logins	=> \@logins,
		    notlogins	=> \@notlogins,	
		);
}

########################
sub showSetLogin {
########################
    $tp = HTML::Template->new(filename => './html/login/showSetLogin.tmpl');
    $tp->param(	
		    uid	    => $query{uid},
		    name    => $UNIT->{$query{uid}}{name},
		    inact   => $LOGIN->{$query{uid}}{inact},
		    'abs'   => $LOGIN->{$query{uid}}{'abs'},
		    mac	    => $LOGIN->{$query{uid}}{mac},
		);
}

########################
sub makeSetLogin {
########################
    my $debug;
    my $cmdstr;
    
    if ($query{uid})
    {
	# Assign uid to password, if password is not defined.
	unless ($query{pass}) { $query{pass} = $query{uid}; }
	
	# Create command string for further processing.
	$cmdstr = "set oid $query{uid} password $query{pass}";
	$cmdstr .= " inact $query{inact}"   if ($query{inact});
	$cmdstr .= " abs $query{abs}"	    if ($query{'abs'});
	$cmdstr .= " mac $query{mac}"	    if ($query{mac});
	$cmdstr .= $query{strict} eq "on" ? " strict" : " nostrict";
	
	$debug.=netams_cmd("service $cfg{nas_lgn}");
	$debug.=netams_cmd("$cmdstr");
	$debug.=netams_cmd("exit");
	$debug.=netams_cmd("save");
    }
    
    $tp = HTML::Template->new(filename => './html/redirect.tmpl');
    $tp->param(params => "&act=view&uid=$query{uid}");
}

##############################
sub showLogout {
##############################
    $tp = HTML::Template->new(filename => './html/login/showLogout.tmpl');
    $tp->param(	
		    uid	    => $query{uid},
		    name    => $UNIT->{$query{uid}}{name},
		);
}

##############################
sub makeLogout {
##############################
    my $debug;
    
    if ($query{uid} and $query{pass})
    {
	$debug.=netams_cmd("service $cfg{nas_lgn}");
	$debug.=netams_cmd("logout oid $query{uid} password $query{pass}");
	$debug.=netams_cmd("exit");
	$debug.=netams_cmd("save");
    }
	
    $tp = HTML::Template->new(filename => './html/redirect.tmpl');
    $tp->param(params => "&act=view&uid=$query{uid}");
}

##############################
sub showLogin {
##############################
    $tp = HTML::Template->new(filename => './html/login/showLogin.tmpl');
    $tp->param(	
		    uid	    => $query{uid},
		    name    => $UNIT->{$query{uid}}{name},
		);
}

##############################
sub makeLogin {
##############################
    my $debug;
    
    if ($query{uid} and $query{pass})
    {
	$debug.=netams_cmd("service $cfg{nas_lgn}");
	$debug.=netams_cmd("login oid $query{uid} password $query{pass}");
	$debug.=netams_cmd("exit");
	$debug.=netams_cmd("save");
    }
	
    $tp = HTML::Template->new(filename => './html/redirect.tmpl');
    $tp->param(params => "&act=view&uid=$query{uid}");
}

1;
