use strict;

my %switch =
(
    default	=> \&showInfo,	
    showconf	=> \&showConfig,
    send1	=> \&showSendCommand,
    send2	=> \&makeSendCommand,
);

&{ &chooseAction(\%switch) };

#######################
sub showInfo {
#######################
    $tp = HTML::Template->new(filename => './html/main/showInfo.tmpl');
    $tp->param(data => netams_cmdln("show version"));
}

#######################
sub showConfig {
#######################
    $tp = HTML::Template->new(filename => './html/main/showConfig.tmpl');
    $tp->param(data => netams_cmdln("show config"));
}

######################
sub showSendCommand {
######################
    $tp = HTML::Template->new(filename => './html/main/showSendCommand.tmpl');
}

######################
sub makeSendCommand {
######################
    $query{command} =~ s/(^\s+)|(\s+$)//g;
    
    # Redirect to send1 page if we have no input.
    if ($query{command} eq "")
    {
	$tp = HTML::Template->new(filename => './html/redirect.tmpl');
	$tp->param(params => "&act=send1");
	return;
    }
   
    # Process commands
    my @commands = split (/\n+/, $query{command});
    map (s/(^\s+)|(\s+$)//g, @commands);
   
    my @result;
    foreach my $command (@commands)
    {
	if ($command =~ /^show/)
	{
	    push (@result, { result_data => netams_cmdln("$command") });
	}
	else
	{
	    push (@result, { result_data => netams_cmd("$command") });
	}
    }
    
    $tp = HTML::Template->new(filename => './html/main/makeSendCommand.tmpl');
    $tp->param(result => \@result);
}

1;
