## NeTAMS (www.netams.com) admintool by RamireZ (ramirez@ru.ru)
##
## POLICIES MANAGEMENT MODULE

use strict;

# Load data
my ($UNIT, $UNIT_BYNAME)	= &unitLoadData;
my ($POLICY, $POLICY_BYNAME)	= &policyLoadData;

my %switch =
(
    default	=> \&showList,
    add		=> \&addPolicy,
    rm1		=> \&showDeletePolicy,
    rm2		=> \&makeDeletePolicy,
    edit1	=> \&showEditPolicy,
    edit2	=> \&makeEditPolicy,
);

&{ &chooseAction(\%switch) };

########################
sub addPolicy {
########################
    if ($query{type} ne "" && $query{name} ne "" && $query{target} ne "") 
    {
	my $cmdstr = "policy $query{type} name $query{name} target $query{target} ";
	if ($query{target} eq "tcp-ports" && defined $query{ports}) 
	{ 
	    $cmdstr .= "$query{ports} ";
	}
	
	my $debug.=netams_cmd("service $cfg{nas_prc}");
	$debug.=netams_cmd($cmdstr);
	$debug.=netams_cmd("exit");
	$debug.=netams_cmd("save");
    }
    
    #print "<pre>$debug</pre>";
    
    $tp = HTML::Template->new(filename => './html/redirect.tmpl');
}

########################
sub showList {
########################
    my (@acctlist, @fwlist);

    foreach my $pid (keys %$POLICY)
    {
	my $pollst;
	
	if	($POLICY->{$pid}{type} eq "acct") { $pollst = \@acctlist;	}
	elsif	($POLICY->{$pid}{type} eq "fw")	{ $pollst = \@fwlist;	}
	else					{ next;			}
	    
	push(@$pollst,
	{
	    fn	    => $query{fn},
	    pid	    => $pid,
	    name    => $POLICY->{$pid}{name},
	    targ    => $POLICY->{$pid}{targ},
	    ports   => $POLICY->{$pid}{ports},
	    
	});
    }
    
    $tp = HTML::Template->new(filename => './html/policy/showList.tmpl');
    $tp->param(
		    acctlist => \@acctlist,
		    fwlist	=> \@fwlist, 
		); 
}

########################
sub showEditPolicy {
########################
    my @targ_cbo;
    foreach (qw(ip tcp udp icmp tcp-http tcp-ports))
    {
	if ($POLICY->{$query{pid}}{targ} eq $_) 
	{ 
	    push(@targ_cbo, { targ => $_, selected => ' selected' });
	}
	else
	{ 
	    push(@targ_cbo, { targ => $_ });
	}
    }
    
    my @userlist;
    my $count;
    foreach my $uid (keys %$UNIT)
    {
	foreach my $pid (split (",", $UNIT->{$uid}{policy}{list}))
	{
	    if ($pid eq $query{pid})
	    {
		push(@userlist,
		    {
			uid	=> $uid,
			name	=> $UNIT->{$uid}{name},
			type	=> $UNIT->{$uid}{type},
		    });
		
		$count++;
	    }
	}
    }
    
    $tp = HTML::Template->new(filename => './html/policy/showEditPolicy.tmpl');
    $tp->param(
		    pid	    => $query{pid},
		    polname	    => $POLICY->{$query{pid}}{name},
		    poltype	    => $POLICY->{$query{pid}}{type},
		    ports	    => $POLICY->{$query{pid}}{ports},
		    count	    => $count,
		    targ_cbo    => \@targ_cbo,
		    userlist    => \@userlist,
		); 
}

########################
sub makeEditPolicy {
########################
    my $cmdstr;

    if ($query{newpid} ne "" && $query{newpid} ne $query{pid}) 
    {
	$cmdstr.="oid $query{newpid} " 
    }
    if ($query{name} ne "" && $POLICY->{$query{pid}}{name} ne $query{name})
    { 
	$cmdstr.="name $query{name} "
    }
    if ($query{target} eq "tcp-ports" && $query{ports} ne "" && $POLICY->{$query{pid}}{ports} ne $query{ports})
    {
	$cmdstr .= "target $query{target} $query{ports} ";
    }
    elsif ($query{target} ne "" && $POLICY->{$query{pid}}{targ} ne $query{target}) 
    {
	$cmdstr .= "target $query{target} ";
    }

    my $debug = netams_cmd("service $cfg{nas_prc}");
    $debug .= netams_cmd("policy $POLICY->{$query{pid}}{type} oid $query{pid} $cmdstr");
    $debug .= netams_cmd("exit");
    $debug .= netams_cmd("save");
	
    $tp = HTML::Template->new(filename => './html/redirect.tmpl');
    $tp->param(params => "&act=edit1&pid=$query{pid}"); 
}

########################
sub showDeletePolicy {
########################
    $tp = HTML::Template->new(filename => './html/policy/showDeletePolicy.tmpl');
    $tp->param(
			polname => $POLICY->{$query{pid}}{name},
			pid	=> $query{pid},
			target	=> $POLICY->{$query{pid}}{targ}, 
		    ); 
}

########################
sub makeDeletePolicy {
########################
    my $debug = netams_cmd("service $cfg{nas_prc}");
    $debug.=netams_cmd("no policy fw name $POLICY->{$query{pid}}{name}");
    $debug.=netams_cmd("exit");
    $debug.=netams_cmd("save");
    #print "<pre>$debug</pre>";
	
    $tp = HTML::Template->new(filename => './html/redirect.tmpl');
}

1;
