## NeTAMS (www.netams.com) admintool by RamireZ (ramirez@ru.ru)
##
## QUOTA MANAGEMENT MODULE

use strict;

# Load data
my ($UNIT, $UNIT_BYNAME)	= &unitLoadData;
my ($POLICY, $POLICY_BYNAME)	= &policyLoadData;
my ($QUOTA, $QUOTA_INFO)	= &quotaLoadData;

my %switch =
(
    default	=> \&showList,
    view	=> \&viewQuota,
    setq	=> \&setQuota,
    addquota1	=> \&showAddQuota,
    addquota2	=> \&makeAddQuota,
);

&{ &chooseAction(\%switch) };

########################
sub showList {
########################
    my @quotaunits;
    foreach my $key (keys %$QUOTA)
    {
	push(@quotaunits,
	    {
		fn	=> $query{fn},
		
		uid	=> $key,
		name	=> $UNIT->{$key}{name},
		type	=> $UNIT->{$key}{type},
		
		isenabled => ($QUOTA->{$key}{status} eq "ENABLED" ? 1 : 0),
	    });
    }
    
    $tp = HTML::Template->new(filename => './html/quota/showList.tmpl');
    $tp->param(
			units_total	=> $QUOTA_INFO->{units},
			units_enabled	=> $QUOTA_INFO->{enabled},
			units_active	=> $QUOTA_INFO->{active},
			units_blocked	=> $QUOTA_INFO->{blocked},
			units_notified	=> $QUOTA_INFO->{notified},

			quotaunits	=> \@quotaunits,
		    );
}

########################
sub viewQuota {
########################
    my @quotalist;
    
    foreach my $period (qw(HOUR DAY MONTH TOTAL))
    {
	# Create array item in @quotas_bydest for every destination,
	# store quota info there
	my @quotas_bydest;
	foreach my $dest (qw(in out sum))
	{
	    if ($QUOTA->{$query{uid}}{$period}{$dest}{hard}{limit} ne "")
	    {
		my $ratioimg;
		my $hratio = $QUOTA->{$query{uid}}{$period}{$dest}{hard}{ratio};

		if	($hratio <  15) { $ratioimg = 1; }
		elsif	($hratio <  30) { $ratioimg = 2; }
		elsif	($hratio <  44) { $ratioimg = 3; }
		elsif	($hratio <  58) { $ratioimg = 4; }
		elsif	($hratio <  72) { $ratioimg = 5; }
		elsif	($hratio <= 86) { $ratioimg = 6; }
		elsif	($hratio >  86) { $ratioimg = 7; }

		push (@quotas_bydest,
		    {
			rooturl	    => $cfg{rooturl},
			fn	    => $query{fn},

			uid	    => $query{uid},

			period	    => $period,
			dest	    => $dest,
			ratioimg    => $ratioimg,
			
			hlimit => $QUOTA->{$query{uid}}{$period}{$dest}{hard}{limit},
			slimit => $QUOTA->{$query{uid}}{$period}{$dest}{soft}{limit},	
			hratio => $hratio,
			sratio => $QUOTA->{$query{uid}}{$period}{$dest}{soft}{ratio},
			used => $QUOTA->{$query{uid}}{$period}{$dest}{hard}{used},
		    });
	    }    
	}

	# if we have at least one item in a @quotas_bydest array
	# store that array in a @quotalist array
	push (@quotalist,
			{ 
			    quotas_bydest   => \@quotas_bydest,
			    period	    => $period,
			}) if (@quotas_bydest);
    }

    $tp = HTML::Template->new(filename => './html/quota/viewQuota.tmpl');
    $tp->param(
			uid	=> $query{uid},
			name	=> $UNIT->{$query{uid}}{name},
			type	=> $UNIT->{$query{uid}}{type},
			quotas	=> $QUOTA->{$query{uid}}{quota},
			policy	=> $QUOTA->{$query{uid}}{policy},
			pid	=> $POLICY_BYNAME->{$QUOTA->{$query{uid}}{policy}}{oid},
			treshold => $QUOTA->{$query{uid}}{treshold},
			status	=> $QUOTA->{$query{uid}}{status},
			
			quotalist => \@quotalist,
		    );
}

########################
sub setQuota {
########################
    my $new_quota = $query{quota};
   
    if ($new_quota =~ /^[+-]/)
    {
	$new_quota =~ s/^(.)(.+)$/$2/;

	# if new quota starts with plus,
	# add new quota to old quota
	if	($1 eq "+")
	{
	    $new_quota = &convertToMB($QUOTA->{$query{uid}}{$query{per}}{$query{inoutsum}}{hard}{limit}) + $new_quota;
	}
	# else if new quota starts with minus,
	# substract new quota from old quota
	elsif	($1 eq "-")
	{
	    $new_quota = &convertToMB($QUOTA->{$query{uid}}{$query{per}}{$query{inoutsum}}{hard}{limit}) - $new_quota;
	}
    }
    
    my $debug = &quotaSet($UNIT->{$query{uid}}{name}, $query{per}, $new_quota, $query{inoutsum});
	
    #print "<pre>$debug</pre>";
    
    $tp = HTML::Template->new(filename => './html/redirect.tmpl');
    $tp->param(params => "&act=view&uid=$query{uid}");
}

1;
